window.Gleam.initSearch([{"doc":"glimiter","title":"glimiter","content":"# glimiter\n\n[![Package Version](https://img.shields.io/hexpm/v/glimiter)](https://hex.pm/packages/glimiter)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glimiter/)\n\n```sh\ngleam add glimiter\n```\n```gleam\nimport birl/duration\nimport glimiter\n\npub fn main() {\n  // Creating our limiter to allow 1 request per minute for a given request key\n  let limiter = new_limiter(1, duration.minutes(1))\n\n  // When the request arrives\n  let limiter = update(limiter, &quot;RequestKey&quot;)\n\n  // Using the guard so that when the limit is exceeded, we return the error\n  use &lt;- limit_guard(\n    when: limiter,\n    with: &quot;RequestKey&quot;,\n    return: Error(&quot;Request limit exceeded&quot;),\n  )\n\n  Ok(&quot;Response&quot;)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/glimiter&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## More Examples\n\n - [Single Limiter](https://github.com/H-274/glimiter/blob/main/examples/single_limiter.gleam)\n - [Multiple Limiters](https://github.com/H-274/glimiter/blob/main/examples/multi_limiter.gleam)\n","url":"index.html"},{"doc":"glimiter","title":"Limiter","content":"pub opaque type Limiter(a)\n\n\nSynonyms:\nglimiter.Limiter\nglimiter Limiter","url":"glimiter.html#Limiter"},{"doc":"glimiter","title":"limit_guard","content":"pub fn limit_guard(\n  when limiter: Limiter(a),\n  with key: a,\n  return consequence: b,\n  otherwise alternetive: fn() -&gt; b,\n) -&gt; b\n\nSynonyms:\nglimiter.limit_guard\nglimiter limit_guard","url":"glimiter.html#limit_guard"},{"doc":"glimiter","title":"new_limiter","content":"pub fn new_limiter(count: Int, size: Duration) -&gt; Limiter(a)\n\nSynonyms:\nglimiter.new_limiter\nglimiter new_limiter","url":"glimiter.html#new_limiter"},{"doc":"glimiter","title":"update","content":"pub fn update(limiter: Limiter(a), key: a) -&gt; Limiter(a)\n\nSynonyms:\nglimiter.update\nglimiter update","url":"glimiter.html#update"},{"doc":"glimiter","title":"glimiter","content":"","url":"glimiter.html"}]);